/*****
* thbullets.c - mostly magical bullet code
*		
*/

#include <PA9.h>
#include "thbullets.h"
#include "thdualsprites.h"
#include "menuscroll.h" //just to get an audible indicator for transient event debugging (remove l8tr)
#include "gfx/all_gfx.h"

//The actual bullet structure
struct t_bullets bullets[BULLETS_MAX];


//other globals

//int bdelay=0;

int nextbullet=0;	// this really should just dynamically figure out which bullet is next available but for getting this working...
/******
* Bullet Lib stuff
******/

//init bullet lib
void bulletInit() {
	int c=0;
	do {	//alternate thought memset((void*)bullets,sizeof(bullets),0);	
		bullets[c].flags=0; //This effectively turns off this bullet
		bullets[c].sprite=-1;	//just for safety
	} while(++c!=BULLETS_MAX);
	nextbullet=0;
}


int bulletCreate(void *sprite, struct bsprite_s *bsprite, int x, int y, int xinc, int yinc, int rotset, struct badv_s *badv, struct brad_s *brad, u32 flags, int who) {
	int spriten=0;
	if(brad) {
		bullets[nextbullet].radius=brad->radius<<8;
		bullets[nextbullet].angle=brad->angle<<8;
		bullets[nextbullet].radspd=brad->radspd;
		bullets[nextbullet].anglespd=brad->anglespd;
	} else {
		bullets[nextbullet].radius=-1;	//this means dont bother with radial stuffs plz		
	}
	if(flags&BULLET_FOLLOW) {	//in case ur trying to use this as an offset during follow :D
		xinc=xinc<<8;
		yinc=yinc<<8;
	}
	if(badv) {
		bullets[nextbullet].lcnt=badv->lcnt;
		bullets[nextbullet].mdly=badv->mdly;
		bullets[nextbullet].func=badv->func;
		bullets[nextbullet].follow=badv->follow;
		bullets[nextbullet].msdly=badv->msdly;
		if(!(flags&BULLET_PHANTOM)) spriten=thSpriteCreate(sprite,bsprite->shapex, bsprite->shapey,bsprite->size,bsprite->pal,x-(bsprite->size>>1),y-(bsprite->size>>1),rotset,badv->priority);
		thSpriteSetAlpha(spriten,badv->alpha);

	} else {
		bullets[nextbullet].lcnt=-1;	//-1 will take a huge number of frames before it dies tho this may need to be better coded 								later to actually stop the counter ~_~
		bullets[nextbullet].mdly=0;
		bullets[nextbullet].msdly=0;
		bullets[nextbullet].func=NULL;
		if(!(flags&BULLET_PHANTOM)) spriten=thSpriteCreate(sprite,bsprite->shapex, bsprite->shapey,bsprite->size,bsprite->pal,x-(bsprite->size>>1),y-(bsprite->size>>1),rotset,-1);
	}

	bullets[nextbullet].t1=0;
	bullets[nextbullet].t2=0;
	bullets[nextbullet].ax2=0;
	bullets[nextbullet].ay2=0;
	bullets[nextbullet].x=x; //we consider x,y the CENTER of the sprite
	bullets[nextbullet].y=y;
	bullets[nextbullet].realx=x;
	bullets[nextbullet].realy=y;	//okay since functions and radials may modify actual x,y pos here we have a NEW xypos >_>
	bullets[nextbullet].rotset=rotset; //is this member even needed anymore?
	bullets[nextbullet].xinc=xinc;
	bullets[nextbullet].yinc=yinc;
	bullets[nextbullet].xvfl=(x-(bsprite->size>>1))<<8;
	bullets[nextbullet].yvfl=(y-(bsprite->size>>1))<<8;
//	if(spriten==0) PA_OutputText(0, 4, 17, "bullet %d is 0!?!",nextbullet);
	bullets[nextbullet].sprite=spriten;
	bullets[nextbullet].size=bsprite->size;
	bullets[nextbullet].who=who;
	bullets[nextbullet].hrad=bsprite->hitrad;
	bullets[nextbullet].flags=BULLET_ACTIVE|flags;
	spriten=nextbullet; //store this here temporarily as return value plz
	do {
		if((++nextbullet)==BULLETS_MAX) {
			nextbullet=0;
		}
	} while(bullets[nextbullet].flags);
//	PA_OutputText(0, 4, 19, "next bullet: %d    ",nextbullet);
//	PA_OutputText(1, 4, 6, "nextb: %d   thspr: %d  ",nextbullet, spriten);
	return(spriten); //return bullet handle
}



//This needs a better sprite handler, something more efficient and dynamic at allocation sprites when they move from 
// screen to screen or even if they move off screen (de-aloc the sprite untill it needs to be seen then realloc :)
// ITS BEEN DONE!!!!!! ^^

//Bullet update, called every frame to move stuff these things if necessary
void bulletUpdate(void) {
	int c=0;
	s32 x;
	s32 y; //to speed things up...
	s32 xs;
//	if(bdelay) {
//		if(bdelay==1) bulletsDestroyAllNonSticky();	
//		if(bdelay==1) {
//			bulletsDestroyAllWhoSize(1, 32);
//			bulletsReplaceAllWhoSizeDrop((void*)bbox_Sprite, 1, 16, -2);
//		}
//		bdelay--;
//		return;	//plz to not update the bullets for so many seconds
//	}
	do {
		if(bullets[c].flags) { //we using this one??
			xs=bullets[c].size;
			if(bullets[c].flags&BULLET_FOLLOW) {
				x=(bullets[c].xvfl=bullets[bullets[c].follow].xvfl+bullets[c].xinc)>>8;
				y=(bullets[c].yvfl=bullets[bullets[c].follow].yvfl+bullets[c].yinc)>>8;
				bullets[c].x=x+(xs>>1); //divide by 2
				bullets[c].y=y+(xs>>1); //to update actual center of sprite pos
//	PA_OutputText(0,5,11,"following:%d  x:%d x:%d        ",bullets[c].follow, x,y);  		
			} else {
				if(--bullets[c].msdly==0) { //k so this could prolly be a bit more efficent but basically stop movign after so many frames 0 or less effectively == never stop
					bullets[c].xinc=0;
					bullets[c].yinc=0;
				}
				//acceleration envelope generator go go go !^^!
				if(bullets[c].t1) {
					bullets[c].t1--;
					bullets[c].xinc+=bullets[c].ax1;
					bullets[c].yinc+=bullets[c].ay1;
				}
				if(bullets[c].t2) {
					bullets[c].t2--;
				} else if ((bullets[c].ax2!=0) || (bullets[c].ay2!=0)) {
					bullets[c].xinc+=bullets[c].ax2;
					bullets[c].yinc+=bullets[c].ay2; //these coefficients should be figured b4 hand so less math here as possible!! something like ax2=xinc*a2; :)					
				}
				if(bullets[c].mdly) {
					bullets[c].mdly--; //decrement delay counter
					x=bullets[c].xvfl>>8;
					y=bullets[c].yvfl>>8;
				} else {
					x=(bullets[c].xvfl+=bullets[c].xinc)>>8;
					y=(bullets[c].yvfl+=bullets[c].yinc)>>8;
					bullets[c].x=x+(xs>>1); //divide by 2
					bullets[c].y=y+(xs>>1); //to update actual center of sprite pos
				}
				//for now will keep radius movements outta the delays way
				if(bullets[c].radius>=0) { 
					//note this function can be streamlined using stack vars instead of this but jaja
					if(bullets[c].mdly==0) {
						bullets[c].radius+=bullets[c].radspd;
						bullets[c].angle+=bullets[c].anglespd;
					}
					x+=(PA_Sin(bullets[c].angle>>8)*(bullets[c].radius>>8))>>8;
					y+=((0-PA_Cos(bullets[c].angle>>8))*(bullets[c].radius>>8))>>8;
				}
			}
			bullets[c].realx=x+(xs>>1);
			bullets[c].realy=y+(xs>>1); //is there anyplace xs isnt >>1? if so just make bulletCreate fixor it...
			if(bullets[c].func) {
				((_pBulletFunc)bullets[c].func)(c,bullets[c].who); //call a function
			}
			if(!(bullets[c].flags&BULLET_PHANTOM)) thSpriteSetXY(bullets[c].sprite,x,y);
				if(!(bullets[c].flags&BULLET_STICKY)) {
				//All the reasons to delete the bullet... whew! Much redundancy here need to fix (or prove its faster :)
				if(bullets[c].lcnt==0) {	//Check if our life counter ran out
//PA_OutputText(0, 4, 20, "bulupdt1 told me to destroy 0!");
					bulletsDestroy(c);
				} else {
					bullets[c].lcnt--;
					if(bullets[c].flags&BULLET_WIDE) { //check for almost wrapping around the screen
						if(x>(512-xs) || (y>(637-xs)) || (x<-(512-xs)) || (y<-(86-xs))) {
// PA_OutputText(0, 4, 4, "bulupdt2 told me to destroy 0! %d  %d    ",c,bullets[c].flags);
							bulletsDestroy(c);
						}
					} else {	//check for barely moving off the screen
						if(x>(255+xs) || (y>(384+xs)) || (x<-xs) || (y<-xs)) {
	// PA_OutputText(0, 4, 20, "bulupdt3 told me to destroy 0!");
							bulletsDestroy(c);
						}
					}
				}
			}
		}
        } while(++c!=BULLETS_MAX);
}



//#define bulletsSetFlags(b,fgs) (bullets[b].flags=fgs)
u32 bulletsSetFlags(int bullet,u32 flags) {
	if(bullets[bullet].flags) {
		return bullets[bullet].flags|=flags;
	} else {
		return 0;
	}
}
u32 bulletsClearFlags(int bullet,u32 flags) {
	if(!(bullets[bullet].flags)) {
		return bullets[bullet].flags&=0xffffffff^flags;
	} else {
		return 0;
	}
}


//This Destroys all bullets not flag'd as 'sticky' (umm what? where?)


//replace a bullet with another image, this may expand to actually replace whole bullet but would need bullet's descript struct
void bulletsReplace(int bullet, void *obj, int size, int newwho,u8 pal) {
	if((bullets[bullet].flags>0) && !(bullets[bullet].flags&BULLET_STICKY) && (bullets[bullet].who>0)) {
		if(bullets[bullet].size==size) { //replace
			thSpriteUpdateGfxPal(bullets[bullet].sprite,obj,pal);
			thSpriteUpdateRotset(bullets[bullet].sprite,-1);
			bullets[bullet].rotset=-1;
	//		bullets[bullet].xinc=0;
	//		bullets[bullet].yinc=350+PA_RandMax(400); //new drop rate (toward floor)
			bullets[bullet].who=newwho;
			bullets[bullet].radius=-1;	
			bullets[bullet].lcnt=-1;	
			bullets[bullet].mdly=0;
			bullets[bullet].func=NULL;
		} else {	// or for now destroy
			bulletsDestroy(bullet);
		}
	}
}


//destory all who whoever except player or other dropping bullets
void bulletsReplaceAllSizeDrop(void *obj, int size, int newwho,u8 pal) {
	int c=0;
	do {
		if((bullets[c].flags>0) && !(bullets[c].flags&BULLET_STICKY) && (bullets[c].size==size) && (bullets[c].who>0)) {
//			thSpriteUpdateGfx(bullets[c].sprite,obj);
			thSpriteUpdateGfxPal(bullets[c].sprite,obj,pal);
			thSpriteUpdateRotset(bullets[c].sprite,-1);
			bullets[c].rotset=-1;
			bullets[c].xinc=0;
			bullets[c].yinc=350+PA_RandMax(400); //new drop rate (toward floor)
			bullets[c].who=newwho;
			bullets[c].radius=-1;	
			bullets[c].lcnt=-1;	
			bullets[c].mdly=0;
			bullets[c].func=NULL;
		}
	} while(++c!=BULLETS_MAX);
}

void bulletsReplaceAllWhoSizeDrop(void *obj, int who, int size, int newwho,u8 pal) {
	int c=0;
	do {
		if((bullets[c].flags>0) && !(bullets[c].flags&BULLET_STICKY) && (bullets[c].size==size) && (bullets[c].who==who)) {
			
			//thSpriteUpdateGfx(bullets[c].sprite,obj);
			thSpriteUpdateGfxPal(bullets[c].sprite,obj,pal);
			thSpriteUpdateRotset(bullets[c].sprite,-1);
			bullets[c].rotset=-1;
			bullets[c].xinc=0;
			bullets[c].yinc=350+PA_RandMax(400); //new drop rate (toward floor)
			bullets[c].who=newwho;
			bullets[c].radius=-1;	
			bullets[c].lcnt=-1;	
			bullets[c].mdly=0;
			bullets[c].func=NULL;
		}
	} while(++c!=BULLETS_MAX);
}

void bulletsDestroyAllWho(int who) {
	int c=0;
	do {
		if((bullets[c].flags>0) && !(bullets[c].flags&BULLET_STICKY)&& (who==bullets[c].who)) {
			thSpriteDestroy(bullets[c].sprite);	
			bullets[c].flags=0; //ex-terminate!
		}
	} while(++c!=BULLETS_MAX);
}

void bulletsDestroyAllWhoSticky(int who) { //same as above but without regard to sticky ness
	int c=0;
	do {
		if((bullets[c].flags>0) && (who==bullets[c].who)) {
			thSpriteDestroy(bullets[c].sprite);	
			bullets[c].flags=0; //ex-terminate!
		}
	} while(++c!=BULLETS_MAX);
}

void bulletsDestroyAllFollow(int who) { //same as above but without regard to sticky ness
	int c=0;
	do {
		if((bullets[c].flags>0) && (who==bullets[c].follow)) {
			thSpriteDestroy(bullets[c].sprite);	
			bullets[c].flags=0; //ex-terminate!
		}
	} while(++c!=BULLETS_MAX);
}


void bulletsDestroyAllWhoSize(int who, int size) {
	int c=0;
	do {
		if((bullets[c].flags>0) && !(bullets[c].flags&BULLET_STICKY) && (bullets[c].size==size) && (who==bullets[c].who)) {
			thSpriteDestroy(bullets[c].sprite);	
			bullets[c].flags=0; //ex-terminate!
		}
	} while(++c!=BULLETS_MAX);
}

void bulletsSetAllWhoAlpha(int who, u8 alpha) {
	int c=0;
	do {
		if((bullets[c].flags>0) && (who==bullets[c].who)) {
			thSpriteSetAlpha(bullets[c].sprite,alpha);	
		}
	} while(++c!=BULLETS_MAX);	
}

void bulletsDestroyAllSize(int size) {
	int c=0;
	do {
		if((bullets[c].flags>0) && !(bullets[c].flags&BULLET_STICKY) && (bullets[c].size==size) && (bullets[c].who>0)) {
			thSpriteDestroy(bullets[c].sprite);	
			bullets[c].flags=0; //ex-terminate!
		}
	} while(++c!=BULLETS_MAX);

}


//This Destroys all bullets not flag'd as 'sticky'
void bulletsDestroyAllNonSticky(void) {
	int c=0;
	do {
		if((bullets[c].flags>0) && !(bullets[c].flags&BULLET_STICKY)) {
//	if(bullets[c].sprite==0) PA_OutputText(0, 4, 20, "It told me to erase 0 Destroy all stick!");
			thSpriteDestroy(bullets[c].sprite);	
			bullets[c].flags=0; //ex-terminate!
		}
	} while(++c!=BULLETS_MAX);
}

//This Destroys all bullets regardless of how icky they are
void bulletsDestroyAll(void) {
	int c=0;
	do {
		if(bullets[c].flags>0) {
//	if(bullets[c].sprite==0) PA_OutputText(0, 4, 20, "It told me to erase 0 Destroy all!");
			thSpriteDestroy(bullets[c].sprite);	
			bullets[c].flags=0; //ex-terminate!
		}
	} while(++c!=BULLETS_MAX);
}


void bulletsDestroy(int bullet) {
	int c=0;
	if(bullets[bullet].flags) {
		//first make sure i have no followers... this is way cpu intensive ://
		do {
			if((bullets[c].flags&BULLET_FOLLOW) && (bullets[c].follow==bullet)) {
				bullets[c].flags=0; //we've gone way off the screen so terminate updates
				if(!(bullets[c].flags&BULLET_PHANTOM)) thSpriteDestroy(bullets[c].sprite);
//	if((bullets[c].sprite<0) || (bullets[c].sprite>=BULLETS_MAX)) PA_OutputText(0, 4, 20, "It told me to erase %d Destroy!",bullets[c].sprite);
				bullets[c].sprite=-1;
			}
		} while(++c!=BULLETS_MAX);
		bullets[bullet].flags=0; //we've gone way off the screen so terminate updates
		if(!(bullets[bullet].flags&BULLET_PHANTOM)) thSpriteDestroy(bullets[bullet].sprite);
		bullets[bullet].sprite=-1;
	}
}

//sets acceleration curves propotionally to already set x/yinc 
//This is great for when u have a projectile u wanna slow/speed up after setting direction with x/yinc...
void bulletsSetAcceleration(int bullet, int t1, int a1, int t2, int a2) {
	if(bullets[bullet].flags) {
		bullets[bullet].t1=t1;
		bullets[bullet].ax1=((bullets[bullet].xinc)*a1)>>8;
		bullets[bullet].ay1=((bullets[bullet].yinc)*a1)>>8;	//setup coefs 
		bullets[bullet].t2=t2;
		bullets[bullet].ax2=((bullets[bullet].xinc)*a2)>>8;
		bullets[bullet].ay2=((bullets[bullet].yinc)*a2)>>8;
	}
}

//This sets x and y acceleration seperately allowing for movement, pause, movement, type actions and moar!! :P~~ best effect eva!!
void bulletsSetAccelerationCoefs(int bullet, int t1, int ax1, int ay1, int t2, int ax2, int ay2) {
	if(bullets[bullet].flags) {
		bullets[bullet].t1=t1;
		bullets[bullet].ax1=ax1;
		bullets[bullet].ay1=ay1;	//setup coefs 
		bullets[bullet].t2=t2;
		bullets[bullet].ax2=ax2;
		bullets[bullet].ay2=ay2;
	}
}

