/*************
* touhou game related stuffs
*************/

#ifndef THGOODNESS_H
#define THGOODNESS_H

#include <PA9.h>
//This will be used a bit everywhere

#define MAXENTITIES 12

#define PLYRPAL 0	//pallet to use for bullets and their bullets (one for each boss)
#define FAMPAL 7	//pallet for familiars and thier bullets (global pallet for all familiars) (mebbe later on a per stage fam pal? dunno)
#define BOSSPAL 3	//pallet for bosses and their bullets
#define MENUTXTPAL 4	//all the pallets we need!
#define DIALOGPAL  5	//used for large images (since bosspal may not be loaded before dialog)

#include "thbullets.h"
//#include "thspells.h" //this is a dependancy nightmare!>_!

/* 
 a few notes on naming, touhou engine functions must start with th (preferably variables, structs too)
 libraryFunctionName() <--- where library is ofc the library and FunctionName is the function name with every other letter of each word capital 
 (tho i havent followed either of these but during cleanup.. :)
 Structs have first letter capitalized
 most of these come from vxWorks naming and i just think it looks nicer and is shorter than blah_blah_blah 
 spea
 
*/
/*
 working from front to back for a change, starting with scenarios \^_^/
*/


#define STAGEDESCTIME 0x150	//how long to the stage description info should linger

//StageStep types
#define STAGE_BG	0x1	//changes (or starts) a new background 
#define STAGE_BGM	0x2	//start bg music
#define STAGE_SUMMON	0x3	//start an enemy character
#define STAGE_DIALOG	0x4	//start dialog
#define STAGE_FINISH	0x5	//do stage ending effect, dissappear all enemys
#define STAGE_UNLOCK	0x6	//unlock a player, or level or something ill finish that thought later...
//#define STAGE_SUMMONB	0x7	//start boss enemy (little different as she is persistant and dont die at 0 health!)
#define STAGE_SPELLCAST	0x8	//start spell
#define STAGE_SPELLSTOP 0x9	//stop spell
#define STAGE_BANISH	0xa	//removes an entity
#define STAGE_SHOWLVL	0xb	//shows the player the level intro (this is here so u can have suprize attacks :P)
#define STAGE_SETGFLAGS	0xc	//makes player 'unsafe' as in she can now be killed again (cleared when dialogs start...)
#define STAGE_SPELLPAUSE 0xd	//pauses a spell
#define STAGE_SPELLRESUME 0xe	//resumes paused spell
#define STAGE_BGMSTOP	0xf	//stops bgm
#define STAGE_ENTITYSTOP 0x10	//stops an entity from moving
#define STAGE_ENTITYMOVE 0x11	//sets entity moving in a particular direction (u must stop it yerself or let it go off screen, x, y, and ndx = speed (as in how many frames before i should be there)
#define STAGE_SETHEALTH	0x12	//sets entity's health to ndx
#define STAGE_CLEARGFLAGS 0x13	//This signifying begin of of a spell group or cluster or wtf ever im gonna call it for now it has this no-sense splstatrst title but it resets the spellbomb used and life lost flags..
#define STAGE_STRTSPLGRP 0x14	//start spell group
#define STAGE_ENDSPLGRP	0x15	//end spell group
#define STAGE_HALT	0x16	//Stops advancing stage script (untill its cleared by like say dialog functs)
#define STAGE_BOSSDEATH	0x18	//activates boss death seq...

#define NOCHR	(Character *)NULL

//what class of character am i? (also tells the which pallet to use...)
#define CCLASS_PLYR	0x1
#define CCLASS_BOSS	0x2
#define CCLASS_FAMILIAR 0x3

typedef struct {
	const char 	*name;
	const char	*text;		//longer description
	void		*fgsprite;	//on enemies this is mebbe a frame or two of animations... 
					//on players its 4 frames for move direction for each of focused/unfocused
	void		*bgsprite;	//sprite to use as character's bg (can be NULL for none)
	void		*pallet;	//pointer to a pallet for this sprite (not all familiars use same pallet even tho they are diff characters)
	int		rotspeed;	//rotation of bg sprite's speed/direction
	int		hitsz;		//Hitbox size
	int 		grazesz; 	//grazebox size	(not used by enemy, yet could make it be less -heath if within graze range?)
	int		speed; 		//unfocused speed
	int		fspeed;		//focused speed (these are not used by enemys)
	int		class;		//what class is this player?
	int		points;		//how much im worth to kill (for enemys obviously)
	struct Spells	*grimoire;	//this players book of spells
	struct thDialog **dialog;	//thdialog [][] (not used by players)
	void		*bullets;	//this player's bullet sprites (some type of pattern/function should be defined for shooting...)
} Character;

struct StageSteps {
	unsigned char	type;	//what type of stage step?
	int		wait;	//how long to wait between this step and next... 0 = instantly go this frame, -1 = wait for enemy death? or just wait untill wait is set to 0 or 1 ??
	int		index;	//Which character dialogscript or spellscript or song or background
	Character 	*chr;	//Which character is involved (for dialog or spell types) so guess i need a character list!
	int		entity;	//better than who
	int		x;	//starting x,y position used for variation among spells
	int		y;
//	u8		flags;	//special flags for this one <_< dont need flags as just make a type to set clear something? mebbe not as ez code wise

};

struct Stage {
	void *sprite;	//this stages name
	const char *text;	//text to appear on the screen during introduction
	struct StageSteps *steps;
};




typedef int(*_pEnemyFunc)(int);	//Enemy function pointer type

unsigned char thPlayerHit(unsigned int *frame); //player has been hit callback

extern struct sPlayer player;
extern u32 hiscore;
extern u32 score;
extern u32 splbeattime;

//These should be someplace else? ill see where all they get used.. then decide, thinking spells?? :D
extern int brotset0;
extern int brotset1;

#define PLRSP	126	//player sprite (and +1 = player bg sprite)



//Backgrounds table
struct Background {
	void *setup;
	void *update;
};

extern struct Background backgrounds[];

typedef void(*_pBgSetupFunc)(void);	//Enemy function pointer type
typedef void(*_pBgUpdateFunc)(int);	//Enemy function pointer type


//Struct for player (and should possibly contain player's familiar related stuffs
struct sPlayer {
	int 	x;		//player current x pos (to center of sprite)
	int	y;		//player current y pos
	int	sx;		//subx and suby 
	int	sy;
	int	hitsz;		//Hitbox size
	int	grazesz; 	//grazebox size
	u32	score;		//player's score
	u32	graze;		//graze points
	u32	time;		//time points
	u32	bonus;		//bonus
	u32	spellbonus;	//points for surviving enemy spells
	int	spells;		//how many spells do i got left
	int	speed;		//normal speed
	int	fspeed;		//focused speed
	int	lives;		//how many loli lives left
	int	firedly;	//delay between firing if key is held...
	int	focused;	//if they player is focused =1 if not =0 this may later be used to pass pressure sense from touchpad?
	int	invcnt;		//player invincibility counter (set to a number of frames the player cant be hurt)
	u8	rotset;
	u8	fgsprite;	//player forground sprite
	u8	bgsprite;	//player bgsprite
};



//some gameflags
#define GFLAGS_PSAFE 	0x1	//player cannot be hit
#define GFLAGS_ESAFE 	0x2	//enemy cannot be hit
#define GFLAGS_SPHALT 	0x4	//halt all spells
#define GFLAGS_PHASDIED	0x8	//these two cleared at start of spellgroup if player dies
#define GLFAGS_PHASBOMB	0x10	//or uses spell bomb these get set and looses the appropriate bonus ;_;
#define GFLAGS_HIDEHEALTH 0x20	//Hides the health bar (for when are no enemys, its hide because then its easy to clear at tart of spell group along with hasdied and hasbomb :)
#define GFLAGS_ISREPLAY	0x40	//are we running in replay mode or the real thing?

//struct bsprite_s bsprite;

extern u32 timeLived;	//how long the player's been alive
extern s32 thDialog;
extern struct sPlayer player;
extern u32 gameFlags;


void thEraseTxtArea(int screen, char xa, char ya, char xb, char yb);
int thPlayerUpdate(u32 frame,Character *);
void thPlayerCreate(Character *);
void thGameStart(u8 player, u8 difficulty, u8 spell, u8 flags);
void thGameOver(u32 frame);
u32 thDelay(u32 frame, u32 dly);

//Scroll both frames and do vbl stuffs macro
void thDualVBLScroll(int frame);

#endif
