#ifndef THMENU_H
#define THMENU_H

#include "thgoodness.h"

typedef int(*_pMENU)(void);	//Menu function pointer type
					//call like this: ((_pMENU)t_cmd[index]->funct)()

//defines
#define MENU_EXIT	0	//return from funct (with given return value)
#define MENU_MENU	1	//This item points to another menu
#define MENU_FUNC	2	//This item points to some function to do
#define MENU_OTHER	4
#define MENU_END	0xff	//indicates this is the last menu entry


//structures
struct thMenuItemGfx {
	void	*sprite;	//which sprite do we use? (its 2 sprites 64x32 with second one pasted direct under
	char	type;		//what type of item is this?
	void 	*location;	//location (this way menu can point to songs, functions, other menus, etc)
};


//menu items
struct thMenuItems {
	char 	*name;		//name of the menu item
	char	type;		//what type of item is this?
//	char	subtype;	//this is like 1 = mod 2 = wav file stuff
	void 	*location;	//location (this way menu can point to songs, functions, other menus, etc)
//	s32	size;		//sample size
//	u32	rate;		//sample rate
};


//prototypes
char thMenu(void);
int menuSelect(struct thMenuItems *, char, char,int);
#endif
